*************
* Mediator1 *
*************

CMediator=CREATEOBJECT('IMediator')
CCollegue1=CREATEOBJECT('ICollegue','Objet1')
CCollegue2=CREATEOBJECT('ICollegue','Objet2')

CMediator.ATTACH(CCollegue1)
CMediator.ATTACH(CCollegue2)
CCollegue1.SendMessage('Objet2','Le message')

DEFINE CLASS ICollegue AS CUSTOM

	oMediator=NULL

	PROCEDURE INIT(tcName)
		THIS.NAME=tcName
	ENDPROC

	PROCEDURE SetMediator(toMediator)
		THIS.oMediator=toMediator
	ENDPROC

	PROCEDURE SendMessage(tcTo,tcMessage)
		IF !ISNULL(THIS.oMediator)
			THIS.oMediator.SendMessage(THIS.NAME,tcTo,tcMessage)
		ENDIF
	ENDPROC

	PROCEDURE GetMessage(tcFrom,tcMessage)
		? THIS.NAME+' '+tcFrom+' '+tcMessage
	ENDPROC

ENDDEFINE

DEFINE CLASS IMediator AS CUSTOM

	oCollegues=NULL

	PROCEDURE INIT()
		THIS.oCollegues=CREATEOBJECT('collection')
	ENDPROC

	PROCEDURE ATTACH(oCollegue)
		THIS.oCollegues.ADD(oCollegue,oCollegue.NAME)
		oCollegue.oMediator=THIS
	ENDPROC

	PROCEDURE Detach(oCollegue)
		oCollegue.oMediator=NULL
		THIS.oCollegues.REMOVE(oCollegue.NAME)
	ENDPROC

	PROCEDURE SendMessage(tcFrom,tcTo,tcMessage)
		loCollegue=THIS.oCollegues(tcTo)
		loCollegue.GetMessage(tcFrom,tcMessage)
	ENDPROC

ENDDEFINE

