*************
* Observer3 *
*************

CSubject=CREATEOBJECT('ISubject')
CObserver1=CREATEOBJECT('IObserver','Observateur1')
CObserver2=CREATEOBJECT('IObserver','Observateur2')
CObserver3=CREATEOBJECT('IObserver','Observateur3')

_SCREEN.CLS
_SCREEN.FONTSIZE=20

CSubject.Attach(CObserver1)
CSubject.Attach(CObserver2)
CSubject.Attach(CObserver3)
CSubject.Notify()

CSubject.Detach(CObserver2)
CSubject.Notify()

CSubject.Attach(CObserver2)
CSubject.Notify()

CSubject.Detach(CObserver1)
CSubject.Detach(CObserver2)
CSubject.Detach(CObserver3)
CSubject.Notify()

_SCREEN.FONTSIZE=10

CLEAR ALL

DEFINE CLASS IObserver AS CUSTOM

	PROCEDURE INIT(tcName)
		THIS.NAME=tcName
	ENDPROC

	PROCEDURE Update(toDoc)
		? "Update "+THIS.NAME
	ENDPROC

ENDDEFINE

DEFINE CLASS ISubject AS CUSTOM

	oObservers=NULL

	PROCEDURE INIT()
		THIS.oObservers=CREATEOBJECT('collection')
	ENDPROC

	PROCEDURE Attach(oObserver)
		THIS.oObservers.ADD(oObserver,oObserver.NAME)
	ENDPROC

	PROCEDURE Detach(oObserver)
		THIS.oObservers.REMOVE(oObserver.NAME)
	ENDPROC

	PROCEDURE Notify()
		? '------------------'
		? "Notify "+THIS.NAME
		?
		FOR EACH loObj AS IObserver IN THIS.oObservers
			loObj.Update(THIS)
		ENDFOR
		? '------------------'
	ENDPROC

ENDDEFINE
