*************
* Template2 *
*************

LOCAL oJeu

_SCREEN.CLS
_SCREEN.FONTSIZE=20

oJeu=CREATEOBJECT('CMonopoly')
oJeu.JouerUnePartie(3)
RELEASE oJeu

_SCREEN.FONTSIZE=10

CLEAR ALL

DEFINE CLASS AJeuDeSociete AS CUSTOM

	PROTECTED nombreDeJoueurs
	nombreDeJoueurs=0

	FUNCTION JouerUnePartie(tnJoueur)

		LOCAL lnJoueur

		THIS.nombreDeJoueurs=tnJoueur
		THIS.InitialiserLeJeu()

		lnJoueur=0
		DO WHILE (!THIS.PartieFinie())
			THIS.FaireJouer(lnJoueur)
			lnJoueur=MOD(lnJoueur+1,THIS.nombreDeJoueurs)
		ENDDO

		THIS.ProclamerLeVainqueur()

	ENDFUNC

	PROTECTED FUNCTION InitialiserLeJeu()
	ENDFUNC

	PROTECTED FUNCTION FaireJouer(tnJoueur)
	ENDFUNC

	PROTECTED FUNCTION PartieFinie()
	ENDFUNC

	PROTECTED FUNCTION ProclamerLeVainqueur()
	ENDFUNC

ENDDEFINE

DEFINE CLASS CMonopoly AS AJeuDeSociete

	HIDDEN NomJeu,NombreTour,NombrePassage
	NomJeu='Monopoly'
	NombreTour=2
	NombrePassage=0

	PROTECTED FUNCTION InitialiserLeJeu()
		? 'Dbut '+THIS.NomJeu
		THIS.NombrePassage=0
	ENDFUNC

	PROTECTED FUNCTION FaireJouer(tnJoueur)
		THIS.NombrePassage=THIS.NombrePassage+1
		? THIS.NomJeu+' : joueur '+ALLTRIM(STR(tnJoueur,5,0))+' passage '+ALLTRIM(STR(THIS.NombrePassage,5,0))
	ENDFUNC

	PROTECTED FUNCTION PartieFinie()
		RETURN (THIS.NombrePassage>=THIS.NombreTour*THIS.nombreDeJoueurs)
	ENDFUNC

	PROTECTED FUNCTION ProclamerLeVainqueur()
		? 'Fin '+THIS.NomJeu
		?
	ENDFUNC

ENDDEFINE
