*********************
* NotesDeFrais2.prg *
*********************

PUBLIC oBigBoss,oDepartement,oService

oBigBoss=CREATEOBJECT('CBigBoss')
oDepartement=CREATEOBJECT('CDepartement')
oService=CREATEOBJECT('CService')

_SCREEN.CLS
_SCREEN.FONTSIZE=20
RbtFrais(100)
RbtFrais(400)
RbtFrais(1000)
RbtFrais(0)
?
_SCREEN.FONTSIZE=10

RELEASE oService
RELEASE oDepartement
RELEASE oBigBoss

CLEAR ALL

FUNCTION RbtFrais(tnMontant)
	LOCAL lcStr
	lcStr=oService.NoteDeFrais(tnMontant)
	IF !ISNULL(lcStr)
		? lcStr
	ELSE
		lcStr=oDepartement.NoteDeFrais(tnMontant)
		IF !ISNULL(lcStr)
			? lcStr
		ELSE
			lcStr=oBigBoss.NoteDeFrais(tnMontant)
			IF !ISNULL(lcStr)
				? lcStr
			ELSE
				? 'Montant '+ALLTRIM(STR(tnMontant,10,0))+' non trait'
			ENDIF
		ENDIF
	ENDIF
ENDFUNC

DEFINE CLASS AResponsable AS CUSTOM

	FUNCTION NoteDeFrais(tnMontant) AS STRING
		RETURN NULL
	ENDFUNC

ENDDEFINE

DEFINE CLASS CService AS AResponsable

	FUNCTION NoteDeFrais(tnMontant) AS STRING
		IF tnMontant>0 AND tnMontant<=250
			RETURN 'Montant '+ALLTRIM(STR(tnMontant,10,0))+' trait par le chef de service'
		ELSE
			RETURN NULL
		ENDIF
	ENDFUNC

ENDDEFINE

DEFINE CLASS CDepartement AS AResponsable

	FUNCTION NoteDeFrais(tnMontant) AS STRING
		IF tnMontant>250 AND tnMontant<=500
			RETURN 'Montant '+ALLTRIM(STR(tnMontant,10,0))+' trait par le chef de dpartement'
		ELSE
			RETURN NULL
		ENDIF
	ENDFUNC

ENDDEFINE

DEFINE CLASS CBigBoss AS AResponsable

	FUNCTION NoteDeFrais(tnMontant) AS STRING
		IF tnMontant>500
			RETURN 'Montant '+ALLTRIM(STR(tnMontant,10,0))+' trait par le big boss qui trouve vos dpenses un peu excessives'
		ELSE
			RETURN NULL
		ENDIF
	ENDFUNC

ENDDEFINE
