*********************
* NotesDeFrais6.prg *
*********************

LOCAL oBigBoss,oDepartement,oService

oBigBoss=CREATEOBJECT('CBigBoss')
oDepartement=CREATEOBJECT('CDepartement')
oService=CREATEOBJECT('CService')

_SCREEN.CLS
oService.AffecteSuivant(oDepartement)
oDepartement.AffecteSuivant(oDepartement)
oBigBoss.AffecteSuivant(NULL)
oService.Test() && pas vraiment le bon chanage !

RELEASE oService
RELEASE oDepartement
RELEASE oBigBoss

CLEAR ALL

DEFINE CLASS AResponsable AS CUSTOM

	HIDDEN oSuivant
	oSuivant=NULL

	FUNCTION AffecteSuivant(toSuivant AS Responsable)
		THIS.oSuivant=toSuivant
	ENDFUNC

	FUNCTION RbtFrais(tnMontant) AS STRING
		LOCAL lcResult
		lcResult=THIS.NoteDeFrais(tnMontant)
		IF !ISNULL(lcResult)
			RETURN lcResult
		ENDIF
		IF !ISNULL(THIS.oSuivant)
			RETURN THIS.oSuivant.RbtFrais(tnMontant)
		ENDIF
		RETURN THIS.DemandeParDefaut(tnMontant)
	ENDFUNC

	PROTECTED FUNCTION NoteDeFrais(tnMontant) AS STRING
		RETURN NULL
	ENDFUNC

	HIDDEN FUNCTION DemandeParDefaut(tnMontant) AS STRING
		RETURN 'Montant '+ALLTRIM(STR(tnMontant,10,0))+' non trait'
	ENDFUNC

	FUNCTION Test()
		? THIS.RbtFrais(100)
		? THIS.RbtFrais(400)
		? THIS.RbtFrais(1000)
		? THIS.RbtFrais(0)
		?
	ENDFUNC

ENDDEFINE

DEFINE CLASS CService AS AResponsable

	PROTECTED FUNCTION NoteDeFrais(tnMontant) AS STRING
		IF tnMontant>0 AND tnMontant<=250
			RETURN 'Montant '+ALLTRIM(STR(tnMontant,10,0))+' trait par le chef de service'
		ELSE
			RETURN NULL
		ENDIF
	ENDFUNC

ENDDEFINE

DEFINE CLASS CDepartement AS AResponsable

	PROTECTED FUNCTION NoteDeFrais(tnMontant) AS STRING
		IF tnMontant>250 AND tnMontant<=500
			RETURN 'Montant '+ALLTRIM(STR(tnMontant,10,0))+' trait par le chef de dpartement'
		ELSE
			RETURN NULL
		ENDIF
	ENDFUNC

ENDDEFINE

DEFINE CLASS CBigBoss AS AResponsable

	PROTECTED FUNCTION NoteDeFrais(tnMontant) AS STRING
		IF tnMontant>500
			RETURN 'Montant '+ALLTRIM(STR(tnMontant,10,0))+' trait par le big boss qui trouve vos dpenses un peu excessives'
		ELSE
			RETURN NULL
		ENDIF
	ENDFUNC

ENDDEFINE
