*************
* Observer1 *
*************

CSubject=CREATEOBJECT('ISubject')
CObserver1=CREATEOBJECT('IObserver','Observateur1')
CObserver2=CREATEOBJECT('IObserver','Observateur2')
CObserver3=CREATEOBJECT('IObserver','Observateur3')

_SCREEN.CLS
_SCREEN.FONTSIZE=20

CSubject.ATTACH(CObserver1)
CSubject.ATTACH(CObserver2)
CSubject.ATTACH(CObserver3)
CSubject.NOTIFY()

CSubject.Detach(CObserver2)
CSubject.NOTIFY()

CSubject.ATTACH(CObserver2)
CSubject.NOTIFY()

CSubject.Detach(CObserver1)
CSubject.Detach(CObserver2)
CSubject.Detach(CObserver3)
CSubject.NOTIFY()

_SCREEN.FONTSIZE=10

CLEAR ALL

DEFINE CLASS IObserver AS CUSTOM

	oSubject=NULL

	PROCEDURE INIT(tcName)
		THIS.NAME=tcName
	ENDPROC

	PROCEDURE UPDATE()
		IF !ISNULL(THIS.oSubject)
			? "Update "+THIS.NAME+' '+THIS.oSubject.NAME
		ENDIF
	ENDPROC

ENDDEFINE

DEFINE CLASS ISubject AS CUSTOM

	oObservers=NULL

	PROCEDURE INIT()
		THIS.oObservers=CREATEOBJECT('collection')
	ENDPROC

	PROCEDURE ATTACH(oObserver)
		THIS.oObservers.ADD(oObserver,oObserver.NAME)
		oObserver.oSubject=THIS
	ENDPROC

	PROCEDURE Detach(oObserver)
		oObserver.oSubject=NULL
		THIS.oObservers.REMOVE(oObserver.NAME)
	ENDPROC

	PROCEDURE NOTIFY()
		? '------------------'
		? "Notify "+THIS.NAME
		?
		FOR EACH loObj AS IObserver IN THIS.oObservers
			loObj.UPDATE()
		ENDFOR
		? '------------------'
	ENDPROC

ENDDEFINE
